c******conjugate gradient method **** Dr.ronbun p28
      subroutine conj_fem
      use work_arrays
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
c
      dimension dx_cj(iall),dy_cj(iall),dz_cj(iall)
      dimension dx_pre(iall),dy_pre(iall),dz_pre(iall)
      dimension fx_pre(iall),fy_pre(iall),fz_pre(iall)
      dimension xf0(iall),yf0(iall),zf0(iall)
c
      steep_tol = 1.0e-14
      ist = 1
c( region 1 & 2 )
      ien = isub1 + iden1 + isub2 + iden2  ! modified
c
      call tersoff ! set energy gradient (d_{1} = dE_1/dx)
      vij_all = sum(vij)
c
       gam = 0.0d0  ! initialize gam_0
       fx_pre=0.0d0; fy_pre=0.0d0; fz_pre=0.0d0 
       dx_pre=0.0d0; dy_pre=0.0d0; dz_pre=0.0d0 ! d_0
c
       outer: do kk = 1,ntsteps
ccc  update search direction (d_{k} = dE_{k}/dx + gam_{k-1}*d_{k-1}) 
ccc  if k=1 --->  d_1 = dE_1/dx + gam_0 * d_0 (gam_0=0)
      do i = ist,ien
      dx_cj(i) = fx(i) + dx_pre(i)*gam 
      dy_cj(i) = fy(i) + dy_pre(i)*gam 
      dz_cj(i) = fz(i) + dz_pre(i)*gam 
      enddo 
ccc  store the previous data
      do i=ist,ien
      xf0(i)=x(i)       ; yf0(i)=y(i)       ; zf0(i)=z(i)
      fx_pre(i)=fx(i)   ; fy_pre(i)=fy(i)   ; fz_pre(i)=fz(i)
      dx_pre(i)=dx_cj(i); dy_pre(i)=dy_cj(i); dz_pre(i)=dz_cj(i)
      enddo
      vij0 = vij_all
ccc--------------------
      alp = 0.25d0  ! set initial alpha (setting parameter)
      beta_int = 0.25d0 ! 0<beta<1 (independent on CG steps)
ccc--------------------
      inner: do kkk = 1,100  ! calculate alp with nibun-hou
      fff = 0.0d0
      do i=ist,ien  ! x_{?} = x_{k-1} + alp*d_{k-1}
         x(i)=xf0(i)+alp*dx_cj(i)
         y(i)=yf0(i)+alp*dy_cj(i)
         z(i)=zf0(i)+alp*dz_cj(i)
         fff = fff   ! fff : dE_{k-1}/dx * d_{k-1}
     &   + fx(i)*dx_cj(i) + fy(i)*dy_cj(i) +fz(i)*dz_cj(i) 
       enddo
      call ene_sic   ! E_{?}
      vij_all = sum(vij)
ccc vij2 =  E_{k-1} + beta*alp*dE_{k-1}/dx * d_{k-1}
      vij2 = vij0 - beta_int*alp*fff 
c
      write(36,'(2I3,3e21.13,e15.7)')kk,kkk,vij0,vij_all-vij0
     &  ,vij2-vij0,alp
c
       if (vij2 .ge. vij_all) then  ! the Armijo condition
          exit inner
       else
          alp = alp / 2.0d0
          cycle inner
       endif
c
       enddo inner
c
ccc the judgement of the minimization
      vd = vij_all/vij0-1.0
      avd = abs(vij_all/vij0-1.0)
      if ((avd.lt.steep_tol).and.(vd.gt.0.0)) then
         write(6,*)'ENERGY WAS MINIMIZED!' 
         exit outer
      endif
c
ccc x_{k} = x_{k-1} + alp*d_{k-1} ( no need ? )
      do i=ist,ien
         x(i)=xf0(i)+alp*dx_cj(i)
         y(i)=yf0(i)+alp*dy_cj(i)
         z(i)=zf0(i)+alp*dz_cj(i)
      enddo
c 
      call tersoff ! set energy gradient (d_{k} = dE_k/dx)
c
ccc  gam = |df(k+1)/dx|^2 / |df(k)/dx|^2  : Fletcher-Reeves formulation
      gam1 = 0.0d0; gam2 = 0.0d0 ! ; gam3 = 0.0d0
      do i = ist,ien
      gam1 = gam1 + fx(i)*fx(i)+fy(i)*fy(i)+fz(i)*fz(i)
      gam2 = gam2 
     & + fx_pre(i)*fx_pre(i)+fy_pre(i)*fy_pre(i)+fz_pre(i)*fz_pre(i)
c     gam3= gam3 + fx_pre(i)*fx(i)+fy_pre(i)*fy(i)+fz_pre(i)*fz(i)
      enddo
c
      gam = gam1 / gam2
c     gam = (gam1-gam3) / gam2
c
      end do outer
c
      call press
c
      return
      end
