c      SUBROUTINE DATA_FEM(U,EPN,NN)
      SUBROUTINE DATA_FEM
      use fem_arrays  ! U,NN
      use connect     ! EPN
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
c      INCLUDE 'para_fem.inc'
c      INCLUDE 'connect.inc'
c      DIMENSION U(*),EPN(ICOM,*)
c      DIMENSION NN(INMTE,*)
c      dimension ncor(1000,4)
c      dimension pcor(1000,3)
cccc shape function
      dimension sh(8)
c*************************************************************
c
c FEM-DATA --> MD DATA
c  1. FEM NODE = MD ATOM
c        NODE Number = ncor(i,4) = nnode
c        Atom        = ncor(i,1)
c        pm          = ncor(i,2)
c        Internal Disp. : pm * d_con * EPN(4,nnode)
c           [ EPN(4,NNODE) : NODE STRAIN ]
c      NODE DISP. + INTERNAL DISP. --> ATOMIC DISP.
c  2. FEM NODE .ne. MD ATOM
c        ELEMENT NUMBER = ncor(i,5) = nelem
c        Atom        = ncor(i,1)
c        Position in the element
c         xxi=pcor(i,1), eta =pcor(i,2), zeta = pcor(i,3)
c
c      open(34,file='ncor3.dat')
c
c      nr3 = 0
c      nmax = 1000
c      do 10 i = 1,nmax
c      read(34,2222,end=999)(ncor(i,k),k=1,5),(pcor(i,k),k=1,3)
c      nr3 = nr3 + 1
c 10   continue
c 999  continue
c      close(34)
c 2222 format(5i5,3e15.7)
c------------------------------------------     
c  ncor(i,1) : atom number
c  ncor(i,2) : direction of internal displacement
c  ncor(i,4) : node number
c  ncor(i,5) : element number ( if ncor(i,3).eq.0 )
c  pcor(i,1) : xxi_f
c  pcor(i,2) : eta_f
c  pcor(i,3) : zeta_f
c  constrain --> x,y,z direction
c------------------------------------------
c
cccc modified 1998-08-24
c       d_con = 0.9178545068
c       d_con = 0.9178545068/2.0
c       d_con = 0.9173826/2.0
c
       do 20 i = 1,nr3
          nnode = ncor(i,4)
          natom = ncor(i,1)
          pm    = real(ncor(i,2))
c          write(6,*)'plus-minus',pm
c          write(6,*)nnode,natom
c----------------------------------------------------
c**** element
          if (nnode.eq.0) then
c**            write(99,*)'element'
            nelem = ncor(i,5)
            xxi_f   = pcor(i,1)
            eta_f   = pcor(i,2)
            zeta_f  = pcor(i,3)
cc            write(99,*)'x,e,z',pcor(i,1),pcor(i,2),pcor(i,3)
            a1 = 1.0d0 + xxi_f
            b1 = 1.0d0 + eta_f
            c1 = 1.0d0 + zeta_f
            a2 = 1.0d0 - xxi_f
            b2 = 1.0d0 - eta_f
            c2 = 1.0d0 - zeta_f
            dd_f = 1.0d0/8.0d0
c <n> 8node
         sh(1)= a2 * b2 * c2 * dd_f
         sh(2)= a1 * b2 * c2 * dd_f
         sh(3)= a1 * b1 * c2 * dd_f
         sh(4)= a2 * b1 * c2 * dd_f
         sh(5)= a2 * b2 * c1 * dd_f
         sh(6)= a1 * b2 * c1 * dd_f
         sh(7)= a1 * b1 * c1 * dd_f
         sh(8)= a2 * b1 * c1 * dd_f
cccc element number --> local node number
         uxx = 0.0d0
         uyy = 0.0d0
         uzz = 0.0d0
         epn4 = 0.0d0
         epn5 = 0.0d0
         epn6 = 0.0d0
        do 510 iii = 1,8
           kk = NN(iii,nelem)
           k1 = (kk-1)*IDIM + 1
           k2 = (kk-1)*IDIM + 2
           k3 =  kk*IDIM 
cc           write(99,*)kk
cccc displacement interpolation
           uxx = uxx + SH(iii)*u(k1)
           uyy = uyy + SH(iii)*u(k2)
           uzz = uzz + SH(iii)*u(k3)
cccc strain interpolation
           epn4 = epn4 + SH(iii)*EPN(4,kk)
           epn5 = epn5 + SH(iii)*EPN(5,kk)
           epn6 = epn6 + SH(iii)*EPN(6,kk)
 510    continue
cccc internal displacement (ignore z-direction) +- = pm ???
c          uz = d_ijk * ep_jk   
          uzzi = - pm * d_con * epn4
          uyyi = - pm * d_con * epn5
          uxxi = - pm * d_con * epn6
ccc test
c          uzzi = 0.0d0
c          uyyi = 0.0d0
c          uxxi = 0.0d0
c
          ux(natom) = uxx + uxxi
          uy(natom) = uyy + uyyi
          uz(natom) = uzz + uzzi
c
c**        write(99,*)'ATOM',natom,'-->UX=',ux(natom)
c**        write(99,*)'ATOM',natom,'-->UY=',uy(natom)
c**        write(99,*)'ATOM',natom,'-->UZ=',uz(natom)
        else
c----------------------------------------------------
c**** Node
c**          write(99,*)'NODE'
          nfreex = (nnode-1)*IDIM + 1
          nfreey = (nnode-1)*IDIM + 2
          nfreez = (nnode-1)*IDIM + 3
ccc FEM displacement
          uxx = u(nfreex)
          uyy = u(nfreey)
          uzz = u(nfreez)
ccc Internal Displacement (ignore z-direction) +- = pm ???
c          uz = d_ijk * ep_jk   
          uzzi = -pm * d_con * EPN(4,nnode)
          uyyi = -pm * d_con * EPN(5,nnode)
          uxxi = -pm * d_con * EPN(6,nnode)
c
ccc test
c          uzzi = 0.0
c          uyyi = 0.0
c          uxxi = 0.0
c
          ux(natom) = uxx + uxxi
          uy(natom) = uyy + uyyi
          uz(natom) = uzz + uzzi
c
c      write(344,*)'ATOM',natom,'-->UX=',ux(natom),uxx,uxxi
c      write(344,*)'ATOM',natom,'-->UY=',uy(natom),uyy,uyyi
c      write(344,*)'ATOM',natom,'-->UZ=',uz(natom),uzz,uzzi
        endif
 20    continue
c
 2224   format(5i5)
c
        return
        end
