C-----------------------------------------------------------
C  Empirical interatomic potential for Si-C
C    Phys.Rev.B.39(1989)5566
C     J.Tersoff
C           S.Izumi (RDC) [EM3]   Feb.10.1998
C           S.Izumi (Tokyo Univ.) Apr.25.2000
C-----------------------------------------------------------
      subroutine ene_sic
c     (iall,nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,
c     &           x,y,z,fx,fy,fz,stress,vij,
c     &           r,xr,yr,zr,f1,f1d,f1dd,af,bf,daf,dbf,elam2,fnij)
c
      use work_arrays
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
c      include 'para.inc'
c      include 'poten.inc'
c    parameter -> np8=20,np4=6*iall,
c
cccc local variables
      dimension costh(np8),gdcos(np8),gth(np8),rnm(np8),expr(np8)
      dimension gdm(np8),rnrm(np8),betm(np8),alpm(np8),cctd(np8)
      dimension rmk(np8),f1m(np8),f1dm(np8),f1ddm(np8),
     &          xrmk(np8),yrmk(np8),zrmk(np8)
cccc for f1_bnd , f2_bnd 
c*** fnij(1,i) : Number of Si-neighboors of atom i
c*** fnij(2,i) : Number of  H-neighboors of atom i
c*** fnij(3,i) : Number of  C-neighboors of atom i 
c*** fnij(4,i) : Number of    neighboors of atom i 
c                                 = fnij(1,i)+fnij(2,i)+fnij(3,i)
c
c*****reset variables
         vij = 0.0d0
c
c***** the part of 2-body forces which is independent of coordinate number
c          ###Vij=Vji
CCDIR$ IVDEP--- cannot vectorize ? 
cc      xnkmr1=0.0
cc      xnkmr2=0.0
c
cc      call second(xnkmr1)
      do 50 kkk=1,nbrmax
c
        i =nbrall(1,kkk)
        j =nbrall(2,kkk)
        jj=nbrall(3,kkk)
c
        nnc=nc(i)
        xii=x(i)
        yii=y(i)
        zii=z(i)
c
c******only (j > i) calculation 
         if (j.gt.i) then
c
           npr=nbrp(jj,i)
c
            rx=x(j)-xii+hmat(1,1)*npbx(jj,i)+hmat(1,2)*npby(jj,i)
     &         +hmat(1,3)*npbz(jj,i)
            ry=y(j)-yii+hmat(2,1)*npbx(jj,i)+hmat(2,2)*npby(jj,i)
     &         +hmat(2,3)*npbz(jj,i)
            rz=z(j)-zii+hmat(3,1)*npbx(jj,i)+hmat(3,2)*npby(jj,i)
     &         +hmat(3,3)*npbz(jj,i)
cccccc  
            rd2=rx*rx+ry*ry+rz*rz
c    rd = rij
            rd=dsqrt(rd2)
            r(npr)=rd
c
            rninv=1.0d0/rd
c
            xr(npr)=rx*rninv
            yr(npr)=ry*rninv
            zr(npr)=rz*rninv
c
            rxn=rx
            ryn=ry
            rzn=rz
c
c     
          nk1 = nkind(i)
          nk2 = nkind(j)
c
c       write(102,*)kkk,'atom',i,'(',nk1,')-atom',j,'(',nk2,')',rd
c
c
cccc setting R,D
cccc for Si-C system
          call bparam(cutr,cutr_ss,cutr_cs,cutr_cc,nk1,nk2)
          call bparam(cutd,cutd_ss,cutd_cs,cutd_cc,nk1,nk2)
c----------------------------------------------------------------
cccc for Si-H system
c          call bparam(cutr,cutr_ss,cutr_sh,cutr_hh,nk1,nk2)
c          call bparam(cutd,cutd_ss,cutd_sh,cutd_hh,nk1,nk2)
c
cccc  set cutoff distance !!
            cut = cutr + cutd
            cut2= cutr - cutd
c
c     modified 2000-02-14
            pai = 3.141592653589793238462643383279
cc          pai=3.1415926535
            pai2=pai/2.0d0
            dns1=(dsign(1.0d0,cut-rd)+1.0d0)*0.5d0
            dns2=(dsign(1.0d0,rd-cut2)+1.0d0)*0.5d0
            sind=dsin(pai*0.5d0*(rd-cutr)/cutd)
            cosd=dcos(pai*0.5d0*(rd-cutr)/cutd)
            sind3=dsin(pai*1.5d0*(rd-cutr)/cutd)
            cosd3=dcos(pai*1.5d0*(rd-cutr)/cutd)
c     cutoff function fc(rij) & fc'(rij)
c            tang_h1=1.0
c            tang_h2=1.0
c     if (rd.gt.cut)  f1(npr)=0.0d0
c     if (rd.lt.cut2) f1(npr)=1.0d0
c     f1(npr)=(0.5d0-0.5625d0*sind-0.0625d0*sind3)*dns2*dns1+1.0d0-dns2
        f1(npr)=(0.5d0-0.5625d0*sind-0.0625d0*sind3)*dns2*dns1+
     &  1.0d0-dns2
c
c        if (f1(npr).lt.0.0d0) write(6,*)i,j,rd,f1(npr)
c
        f1d(npr)=(-0.28125d0*pai/cutd*cosd -
     &                      0.09375d0*pai/cutd*cosd3)*dns2*dns1
        f1dd(npr)=(0.140625d0*pai*pai/cutd/cutd*sind +
     &                    0.140625d0*pai*pai/cutd/cutd*sind3)*dns2*dns1
cccc for test
c            f1(npr)  = 1.0d0
c            f1d(npr) = 0.0d0
c            f1dd(npr)= 0.0d0
cccc old version
c            tang_h1=dtanh(pai2*(rd-cutr)/cutd)
c            tang_h2=tang_h1*tang_h1
c      f1(npr)=(0.5d0-0.5d0*tang_h1)*ns1
c      f1d(npr)=-0.25d0*pai*(1.0d0-tang_h2)/cutd*ns1
c      f1dd(npr)=0.25d0*pai*pai*tang_h1*(1.0d0-tang_h2)/cutd/cutd*ns1
c      write(668,*)rd,f1(npr),f1d(npr),cutr,cutd
c
cccc for Si-H-C system
c**	fnij(nk2,i) = fnij(nk2,i) + f1(npr)
c**	fnij(nk1,j) = fnij(nk1,j) + f1(npr)
cccc total Nt_ij
c**	fnij(4,i) = fnij(4,i) + f1(npr)
c**	fnij(4,j) = fnij(4,j) + f1(npr)
c***        write(568,*)nstep,i,j,f1(npr)
c
cc--- coordination function N_{Si} , N_{H}
cccccc i=Si(1) j=H(2)  : fn_h(i) --> +1
c         fn_h(i) = fn_h(i) + f1(npr)*(nk2-1)*(2-nk1)
cccccc i=H(2) j=Si(1)  : fn_h(j) --> +1
c         fn_h(j) = fn_h(j) + f1(npr)*(nk1-1)*(2-nk2)
cccccc i=Si(1) j=Si(1) : fn_Si(i) --> +1 , fn_Si(j) --> +1
c         fn_si(i)= fn_si(i)+ f1(npr)*(2-nk2)*(2-nk1)
c         fn_si(j)= fn_si(j)+ f1(npr)*(2-nk2)*(2-nk1)
cc
cccc setting a1,amd1,b2,amd2 -- for Si-H system
cccc for Si-C system
          call bparam(a1,a1_ss,a1_cs,a1_cc,nk1,nk2)      
          call bparam(b2,b2_ss,b2_cs,b2_cc,nk1,nk2)      
          call bparam(amd1,amd1_ss,amd1_cs,amd1_cc,nk1,nk2)
          call bparam(amd2,amd2_ss,amd2_cs,amd2_cc,nk1,nk2)      
c----------------------------------------------------------------
cccc for Si-H system
c          call bparam(a1,a1_ss,a1_sh,a1_hh,nk1,nk2)      
c          call bparam(b2,b2_ss,b2_sh,b2_hh,nk1,nk2)      
c          call bparam(amd1,amd1_ss,amd1_sh,amd1_hh,nk1,nk2)
c          call bparam(amd2,amd2_ss,amd2_sh,amd2_hh,nk1,nk2)      
c
      elam1=a1*dexp(-amd1*rd)
      elam2(npr)=b2*dexp(-amd2*rd)
c
ccccc Vab=af(npr)-bf(npr)*bij
      af(npr)=f1(npr)*elam1
      bf(npr)=f1(npr)*elam2(npr)
c
ccccc daf=daf/dra , dbf=dbf/dra
      daf(npr)=elam1*f1d(npr)-amd1*af(npr)
      dbf(npr)=elam2(npr)*f1d(npr)-amd2*bf(npr)
c
cccc------------------------------------------------------------
c      vij=vij+af(npr)
c
c      ffx=daf(npr)*xr(npr)
c      fx(i)=fx(i)+ffx
c      fx(j)=fx(j)-ffx
cc
c      ffy=daf(npr)*yr(npr)
c      fy(i)=fy(i)+ffy
c      fy(j)=fy(j)-ffy
cc
c      ffz=daf(npr)*zr(npr)
c      fz(i)=fz(i)+ffz
c      fz(j)=fz(j)-ffz
cccc for stress tensor
c      stress(1,1)=stress(1,1)-rx*ffx
c      stress(2,2)=stress(2,2)-ry*ffy
c      stress(3,3)=stress(3,3)-rz*ffz
c      stress(2,1)=stress(2,1)-ry*ffx
c      stress(3,1)=stress(3,1)-rz*ffx
c      stress(3,2)=stress(3,2)-rz*ffy
cc
c      write(6,*)'50',i,j,daf(npr)*xr(npr)
c
cccc------------------------------------------------------------
c
      endif
c
 50   continue
c
cc      call second(xnkmr2)
c      print*," loop 50/tersof=",xnkmr2-xnkmr1
c
c******remaining part of potentials and forces which depends
c       upon environment(3-body forces)
c
      do 100 i=1,iall
         nnc=nc(i)
cccc kind of atom
         nk1 = nkind(i)
cccc coordination number of Si
c         fn_hi = fn_h(i)
c         fn_sii= fn_si(i)
c         fn_tot = fn_hi + fn_sii
c
c**	fsi1 = (nk1-2.0)*(nk1-3.0)/2.0 
c**	fn_tot = fnij(4,i)*fsi1
c        write(101,*)'i,fn_tot',i,fn_tot
cccc for Si-C system
         call dparam( enu, enu_ss, enu_cc,nk1)
         call dparam(enu2,enu2_ss,enu2_cc,nk1)
c
         call dparam(qdd,qdd_ss,qdd_cc,nk1)
         call dparam( qh, qh_ss, qh_cc,nk1)
         call dparam(qcc,qcc_ss,qcc_cc,nk1)
         call dparam(qcd,qcd_ss,qcd_cc,nk1)
         call dparam( qa, qa_ss, qa_cc,nk1)
c
c         call dparam( alp, alp_ss, alp_cc,nk1)
c         call dparam( bet, bet_ss, bet_cc,nk1)
c-------- simplified version for Si-C 
c         alp = no set
c         bet = no set
c
         if (nnc.eq.0) goto 100
         do 200 jj=1,nnc
c *******  The jj-th  neighborhood of atom i is atom j
            j=nbr(jj,i)
c
            nsn=sign(1,j-i)
            npr=nbrp(jj,i)
c
ccccc cutoff
            f1npr=f1(npr)
            if (f1npr.le.0.0d0) go to 199
            f1dnpr=f1d(npr)
            f1ddnpr=f1dd(npr)
c
            xrn=float(nsn)*xr(npr)
            yrn=float(nsn)*yr(npr)
            zrn=float(nsn)*zr(npr)
c
            rn=r(npr)
c
            rxn=xrn*rn
            ryn=yrn*rn
            rzn=zrn*rn
c
            rninv=1.0d0/rn
c
            afnpr=af(npr)
            bfnpr=bf(npr)
            dafnpr=daf(npr)
            dbfnpr=dbf(npr)
            elam2npr=elam2(npr)
c
cccc kind of atom(j)
            nk2 = nkind(j)
c            nknk=nk1*nk2
c
cccc------------------------------------------------------------
cccc   Spline and setting values of F1(N),F2(N) --> f1_bnd,f2_bnd
c         call fspln(f1_bnd,f2_bnd,fn_tot,nk1,nk2)
            f1_bnd=1.0
            f2_bnd=1.0
c         write(66,*)f1_bnd,f2_bnd,fn_tot
cccc------------------------------------------------------------
c       vij=vij+afnpr/2.0*f1_bnd
cccc for atomic potential energy ( not vectorize )
        vij(i) = vij(i) + afnpr/4.0*f1_bnd
        vij(j) = vij(j) + afnpr/4.0*f1_bnd
c
cccc------------------------------------------------------------
cccc Setting R^e(ij),eta,delta
c            call bparam(reqn,req_ss,req_sh,req_hh,nk1,nk2)
c            call bparam(enu,enu_ss,enu_sh,enu_hh,nk1,nk2)
c            call bparam(enu2,enu2_ss,enu2_sh,enu2_hh,nk1,nk2)
cc            write(6,*)nk1,nk2,enu,enu2,reqn
c
cccc for Si-C system
      reqn = 0.0d0
c
      zeta=0.0d0
      if (nnc.eq.1) goto 310
      do 300 kk=1,nnc
         k=nbr(kk,i)
c
c   need vector !!(k=j skip)
        if(k.eq.j) then
       else
c
            nsm=sign(1,k-i)
            mpr=nbrp(kk,i)
c
cccc cut-off
            f1m(kk)=f1(mpr)
            if (f1m(kk).le.0.0d0) go to 299
            f1dm(kk)=f1d(mpr)
            f1ddm(kk)=f1dd(mpr)
c
            xrm=float(nsm)*xr(mpr)
            yrm=float(nsm)*yr(mpr)
            zrm=float(nsm)*zr(mpr)
c            write(6,*)i,k,i2,k2,nq,mpr
       rm=r(mpr)
c
       xrmk(kk)=xrm
       yrmk(kk)=yrm
       zrmk(kk)=zrm
       rmk(kk)=rm
c
      nk3 = nkind(k)
c      nknk2 = nk1*nk2*nk3
c
cc cos(abc)
      costh(kk)=xrn*xrm+yrn*yrm+zrn*zrm
cccc for Si-C system -- a part of g(theta)
      gdcos(kk)=qdd+(qh-costh(kk))*(qh-costh(kk))
cc a part of g(theta)
ccc   gdcos(kk)=gdd+(gh-costh(kk))*(gh-costh(kk))
c
ccc Spline and setting values of H(N) or h
c      call fspgh(gh,fn_tot,nk1,nk2,nk3)
c      write(67,*)nstep,gh,fn_tot
c
ccc setting c,d
c      call bparam3(gc,gc_ss,gc_sh1,gc_sh2,gc_hh,nk1,nk2,nk3)
c      call bparam3(gd,gd_ss,gd_sh1,gd_sh2,gd_hh,nk1,nk2,nk3)
c
cc**modified  gth_t(kk)=(qcd - qcc /gdcos_t(kk))*qa
       gth(kk)=(qcd - qcc /gdcos(kk))*qa
cc dg(theta)/dcosth = cctd(kk)
       cctd0 = -2.0d0 * qcc * (qh -costh(kk)) * qa
       gdcos2 = gdcos(kk) * gdcos(kk)
       cctd(kk) = cctd0 / gdcos2
c
c       gdm(kk) = gd
c      gdcos(kk)=gh - costh(kk)
cc g(theta)
ccc   gth(kk)=gcd - gcc /gdcos(kk)
c      gth(kk)=gc + gd * gdcos(kk)*gdcos(kk)
ccc dg(theta)/dcosth = cctd(kk)
c      cctd(kk) = - 2.0d0 * gd * gdcos(kk)
c
cc r_ab - r_ac  
      rnm(kk)=rn-rm
      rnm2=rnm(kk)*rnm(kk)
cc a part of zeta (exp-term)
ccc      expr(kk)=dexp(amd33*rnm2*rnm(kk))
ccc setting alpha,beta
c      call bparam3(alp,alp_ss,alp_sh1,alp_sh2,alp_hh,nk1,nk2,nk3)
ccc test version !!
c      alp=0.0d0
c      call bparam3(bet,bet_ss,bet_sh1,bet_sh2,bet_hh,nk1,nk2,nk3)
c      nknkm = nk1*nk3
ccc setting R^e(ik)
c      call bparam(reqm,req_ss,req_sh,req_hh,nk1,nk3)
cc      write(55,*)nk1,nk2,nk3,alp,bet,reqm
c
      reqm = 0.0d0
c
c**      alpm(kk) = alp
c**      betm(kk) = bet
cc (r_{ab} -r^e_{ab}) - (r_{ac} - r^e_{ac})
c**      rnrm(kk) = (rn-reqn) - (rm-reqm) 
c**      ibet = int(bet)
c**      exprpp = rnrm(kk)**ibet
c      write(78,'(3I4,3e15.7,i2)')i,j,k,rn,rm,rnrm(kk),ibet
c
c**      if (exprpp.gt.100.0d0)  then
c**         write(99,*)'exprpp error ( exprpp.gt.100)'
c**         stop
c**      else
c**         expr(kk)=dexp(alp * exprpp)
c**      endif
c
c**      ztest=f1m(kk)*gth(kk)*expr(kk)
cc zeta
c**      zeta=zeta+f1m(kk)*gth(kk)*expr(kk)
      zeta=zeta+f1m(kk)*gth(kk)
c
      endif
 299  continue
 300  continue
 310  continue
c
      if (zeta .lt. bug) then
c      write(99,*)'(zeta.lt.bug) in tersoff_h.f'
c      write(99,*)'zeta=',i,j,zeta
      bzn=0.0d0
      else
c     A part of bij
      bzn=zeta**enu
c      stop
      endif
c
c      write(198,*)'zeta=',i,j,zeta
c      write(198,*)'bzn=',bzn
cc bij
      bij=(1.0d0+bzn)**(-enu2)
c
c      vij=vij-bfnpr*bij*f2_bnd
cc for atomic potential energy
      vij(i) = vij(i) - bfnpr*bij*f2_bnd/2.0
      vij(j) = vij(j) - bfnpr*bij*f2_bnd/2.0
c
 199  continue
 200  continue
c
 100  continue
c
      vij_all = 0.0d0
      do i = 1, iall
         vij_all = vij_all + vij(i)
      enddo
c
      end
c
