#### Makefile for trmesh
#    Copyright (C) 1996 T.Ono
PROG	= fem_md
VER	= 1.0
F77	= fort -g 
OS 	= $(MACHINE)
#LIBS	= -lV77 -L$(OS)/. -lXGLF -lX11 -lsocket
##LIBS	= -lV77 -L$(OS)/. -lXGLF -lX11
LDFLAGS	= 

OBJS	=			\
		$(OS)/main.o	\
		$(OS)/int.o	\
		$(OS)/jmat.o	\
		$(OS)/bmat.o	\
		$(OS)/gauss.o	\
		$(OS)/dmat.o	\
		$(OS)/bdbmat.o	\
		$(OS)/gauss2.o	\
		$(OS)/merge.o	\
		$(OS)/data.o	\
		$(OS)/data_md.o	\
		$(OS)/data_ncor.o	\
		$(OS)/data_fem.o	\
		$(OS)/md_init.o	\
		$(OS)/bound.o	\
		$(OS)/bound_r.o	\
		$(OS)/solve_c.o	\
		$(OS)/solve_cg.o	\
		$(OS)/md_iccg.o	\
		$(OS)/femcg3.o	\
		$(OS)/strain.o	\
		$(OS)/stress.o	\
		$(OS)/bmmat.o	\
		$(OS)/output.o	\
		$(OS)/output_av.o	\
		$(OS)/output_md.o	\
		$(OS)/molcal.o	\
		$(OS)/constant.o	\
		$(OS)/monitor.o	\
		$(OS)/energy.o	\
		$(OS)/book_w.o	\
		$(OS)/prbook.o	\
		$(OS)/out.o	\
		$(OS)/tersoff_sic.o	\
		$(OS)/conj_fem.o	\
		$(OS)/ene_sic.o	\
		$(OS)/verlet.o	\
		$(OS)/press.o	\
		$(OS)/matcal.o	\
		$(OS)/bparam.o	\
		$(OS)/config_array.o	\
		$(OS)/average.o	
SRCS	=			\
		main.f		\
		int.f		\
		jmat.f		\
		bmat.f		\
		gauss.f		\
		dmat.f		\
		bdbmat.f	\
		gauss2.f	\
		merge.f		\
		data.f		\
		data_md.f	\
		data_ncor.f	\
		data_fem.f	\
		md_init.f	\
		bound.f		\
		bound_r.f	\
		solve_c.f	\
		solve_cg.f	\
		md_iccg.f	\
		femcg3.f	\
		strain.f	\
		stress.f	\
		bmmat.f		\
		output.f	\
		output_av.f	\
		output_md.f	\
		molcal.f	\
		constant.f	\
		monitor.f	\
		energy.f	\
		book_w.f	\
		prbook.f	\
		out.f		\
		verlet.f	\
		press.f	\
		matcal.f	\
		bparam.f	\
		config_array.f		\
		average.f		\
		ene_sic.f		\
		conj_fem.f		\
		tersoff_sic.f

HDRS	=	
	
$(PROG):	$(OBJS)
		$(F77) $(LDFLAGS) $(OBJS) $(LIBS) -o $(PROG)
		cp -p $(PROG) $(PROG).$(OS)
#		tar cof	 $(PROG)-$(VER)-$(OS).tar $(PROG) 	\
#			 $(SRCS) $(HDRS) $(OBJS) $(PROG).mak
#		gzip -vf $(PROG)-$(VER)-$(OS).tar		\

clean:
		rm -f $(PROG)
		rm -f $(OBJS)

$(OS)/main.o:		$(HDRS)         main.f  
			$(F77) -c -C -o $@ main.f  
$(OS)/int.o:		$(HDRS)         int.f  
			$(F77) -c -C -o $@ int.f  
$(OS)/jmat.o:		$(HDRS)         jmat.f                 
			$(F77) -c -C -o $@ jmat.f 
$(OS)/bmat.o:		$(HDRS)        	bmat.f  
			$(F77) -c -C -o $@	bmat.f  
$(OS)/gauss.o:	 	$(HDRS)        	gauss.f   
			$(F77) -c -C -o $@	gauss.f   
$(OS)/dmat.o:	 	$(HDRS)         dmat.f                  
			$(F77) -c -C -o $@	dmat.f   
$(OS)/bdbmat.o: 	$(HDRS)         bdbmat.f                  
			$(F77) -c -C -o $@	bdbmat.f   
$(OS)/gauss2.o:    	$(HDRS)         gauss2.f                     
			$(F77) -c -C -o $@	gauss2.f      
$(OS)/merge.o:		$(HDRS)         merge.f                  
			$(F77) -c -C -o $@	merge.f   
$(OS)/data.o:	  	$(HDRS)        	data.f    
			$(F77) -c -C -o $@	data.f    
$(OS)/data_md.o: 	$(HDRS)        	data_md.f    
			$(F77) -c -C -o $@	data_md.f    
$(OS)/data_ncor.o: 	$(HDRS)        	data_ncor.f    
			$(F77) -c -C -o $@	data_ncor.f    
$(OS)/data_fem.o: 	$(HDRS)        	data_fem.f    
			$(F77) -c -C -o $@	data_fem.f    
$(OS)/md_init.o: 	$(HDRS)        	md_init.f    
			$(F77) -c -C -o $@	md_init.f    
$(OS)/bound.o:  	$(HDRS)        	bound.f    
			$(F77) -c -C -o $@	bound.f    
$(OS)/bound_r.o:  	$(HDRS)        	bound_r.f    
			$(F77) -c -C -o $@	bound_r.f    
$(OS)/solve_c.o:	$(HDRS)        	solve_c.f   
			$(F77) -c -C -o $@	solve_c.f   
$(OS)/solve_cg.o:	$(HDRS)        	solve_cg.f   
			$(F77) -c -C -o $@	solve_cg.f   
$(OS)/md_iccg.o:	$(HDRS)        	md_iccg.f   
			$(F77) -c -C -o $@	md_iccg.f   
$(OS)/femcg3.o: 	$(HDRS)        	femcg3.f   
			$(F77) -c -C -o $@	femcg3.f   
$(OS)/strain.o: 	$(HDRS)        	strain.f   
			$(F77) -c -C -o $@	strain.f   
$(OS)/stress.o: 	$(HDRS)        	stress.f   
			$(F77) -c -C -o $@	stress.f   
$(OS)/bmmat.o:	 	$(HDRS)        	bmmat.f   
			$(F77) -c -C -o $@	bmmat.f   
$(OS)/output.o:		$(HDRS)        	output.f  
			$(F77) -c -C -o $@	output.f  
$(OS)/output_av.o:	$(HDRS)        	output_av.f  
			$(F77) -c -C -o $@	output_av.f  
$(OS)/output_md.o:	$(HDRS)        	output_md.f  
			$(F77) -c -C -o $@	output_md.f  
#### MD part
$(OS)/molcal.o:		$(HDRS)         molcal.f  
			$(F77) -c -C -o $@ molcal.f  
$(OS)/constant.o:	$(HDRS)         constant.f                 
			$(F77) -c -C -o $@ constant.f 
$(OS)/monitor.o:	$(HDRS)        	monitor.f  
			$(F77) -c -C -o $@	monitor.f  
$(OS)/energy.o: 	$(HDRS)        	energy.f   
			$(F77) -c -C -o $@	energy.f   
$(OS)/book_w.o: 	$(HDRS)         book_w.f                  
			$(F77) -c -C -o $@	book_w.f   
$(OS)/prbook.o: 	$(HDRS)         prbook.f                  
			$(F77) -c -C -o $@	prbook.f   
$(OS)/out.o:    	$(HDRS)         out.f                     
			$(F77) -c -C -o $@	out.f      
$(OS)/verlet.o: 	$(HDRS)         verlet.f                  
			$(F77) -c -C -o $@	verlet.f   
$(OS)/press.o:  	$(HDRS)        	press.f    
			$(F77) -c -C -o $@	press.f    
$(OS)/matcal.o: 	$(HDRS)        	matcal.f   
			$(F77) -c -C -o $@	matcal.f   
$(OS)/bparam.o: 	$(HDRS)        	bparam.f   
			$(F77) -c -C -o $@	bparam.f   
$(OS)/average.o:	$(HDRS)        	average.f  
			$(F77) -c -C -o $@	average.f  
$(OS)/config_array.o:	$(HDRS)        	config_array.f  
			$(F77) -c -C -o $@	config_array.f  
$(OS)/conj_fem.o:	$(HDRS)        	conj_fem.f  
			$(F77) -c -C -o $@	conj_fem.f  
$(OS)/ene_sic.o:	$(HDRS)        	ene_sic.f  
			$(F77) -c -C -o $@	ene_sic.f  
$(OS)/tersoff_sic.o:	$(HDRS)        	tersoff_sic.f  
			$(F77) -c -C -o $@	tersoff_sic.f  

