      subroutine md_init
c--------------------------------------------------------
c   S.Izumi, 2000 for nano-indentation 
c        Atom Si : H : C system
c--------------------------------------------------------
c      use fem_arrays
      use connect
      use work_arrays
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
c**** file open
      logical ex
      integer index
      integer*4 k
      character*60 arg
      external getarg
      k=1
      call getarg ( k, arg )
c
      index = lnblnk(arg)
      if (index.eq.0) then
         arg = 'files'
      index = lnblnk(arg)
c      stop 'need file-directory'
      endif
c     
      do i = 1,ifile
      f_number(i)(1:70) = arg(1:index)
      enddo
c
cccc  for animation (out.f)
      f_number(9)(index+1:70) = '/xy.dat'
      open(21,file=f_number(9),status='unknown')
cccc stress of substrate
      f_number(10)(index+1:70) = '/str_sub.dat'
      open(24,file=f_number(10),status='unknown')
cccc temperature and energy of cluster and substrate
      f_number(11)(index+1:70) = '/tmp-ene.dat'
      open(36,file=f_number(11),status='unknown')
cccc averaging value 
      f_number(12)(index+1:70) = '/ave_sc.dat'
      f_number(13)(index+1:70) = '/ave_atm.dat'
      open(25,file=f_number(12),status='unknown')
      open(26,file=f_number(13),status='unknown')
cccc deleted atom
      f_number(14)(index+1:70) = '/delete.dat'
      open(30,file=f_number(14),status='unknown')
cccc error messages
      f_number(15)(index+1:70) = '/warning.dat'
      f_number(16)(index+1:70) = '/error.dat'
      open(98,file=f_number(15),status='unknown')
      open(99,file=f_number(16),status='unknown')
c
      f_number(17)(index+1:70) = '/nc.dat'
      f_number(18)(index+1:70) = '/atom_disp.dat'
      f_number(19)(index+1:70) = '/atomst.dat'
      f_number(20)(index+1:70) = '/atomep.dat'
c     
c****read parameter( total step,time step,temperature,,,)
c      open(8,file='number.dat',status='old')
      f_number(1)(index+1:70) = '/number.dat'
      open(8,file=f_number(1),status='old')
cccccc new format
      read(8,'(4e15.7)')dt,tff,wm,pex
      read(8,*)ntsteps,ntemp,nstat,nbstep,nout_out,nout_mon,nout_nc
      read(8,*)iall,icls,isub,itmp,ifix,zbc,ztop,cutdeg
c     
      call config_array
c
      write(6,*)('-',i=1,35)   ! '-----------------'
      write(6,*)'total step=',ntsteps
      write(6,*)'time step=',dt
      write(6,*)'temparture=',tff
      write(6,*)'inverse of lattice weight=',wm
      write(6,*)'hydrostatic pressure=0',pex
      write(6,*)'scale temperature or not(0=No scaling,1=scaling)',ntemp
      write(6,*)'initial state(0) or continued state(1)',nstat
      write(6,*)'Book-making cut-off degree',cutdeg
      write(6,*)'Book-making renewal steps',nbstep
      write(6,*)'Animation interval steps',nout_out
      write(6,*)'Monitor interval steps',nout_mon
      write(6,*)'Interval steps of Book output',nout_nc
      write(6,*)'total number of atom',iall
c      write(6,*)' number of cluster atom',icls
c      write(6,*)' number of substrate atom',isub
c      write(6,*)' number of temperature controled atom',itmp
c      write(6,*)' number of fixed atom',ifix
      write(6,*)('-',i=1,35)   ! '-----------------'
 1001 format(i6,4e15.7,1x,2i2,i3)
      close(8)
c non-dimensional temperature
      tf_sub=tff*boltz/ev
      write(6,*)'initial temperature(non-dim)',tf_sub
c
c detect cutoff distance
      vsi = sqrt(3.0*tf_sub)
      write(6,*)'averaging verlocity v=(Si)',vsi
c setting value
      al_max=2.0d0
      dis_si = vsi*dt*nbstep*al_max
      bc_si = dis_si/3.0 + 1.0
      write(6,*)'cutdeg(Si)',bc_si
c
      if (iall.gt.im) then
         write(99,*)'iall.gt.im !'
         stop
      endif
c
c     parameter initalize
      bug = epsilon(1.0d0)
         fx = 0.0d0
         fy = 0.0d0
         fz = 0.0d0
         ddx2 = 0.0d0
         ddy2 = 0.0d0
         ddz2 = 0.0d0
         stress=0.0d0
         avr_at=0.0d0
         avr_sc=0.0d0
c
c*      iall5 = iall/nmlt
c*         fx_m=0.0d0
c*         fy_m=0.0d0
c*         fz_m=0.0d0
c*         ddx2_m = 0.0d0
c*         ddy2_m = 0.0d0
c*         ddz2_m = 0.0d0
c
c****read x,y,z,vx,vy,vz,fx,fy,fz
      f_number(2)(index+1:70) = '/posi.dat'
      open(9,file=f_number(2),status='old')
c
      read(9,*)iiii
      read(9,*)
c
      nsi    =0
      ncarb  =0
      nhydr  =0
c
      write(6,*)'reading initial coordinates & velocity.....'
      do 20 i=1,iall
          read(9,'(i2,6e21.13)')nkk,x(i),y(i),z(i),vx(i),vy(i),vz(i)
c         read(10,1003)fx(i),fy(i),fz(i)
cccc Silicon(14) , Hydrogen(1) , Carbon(6)
          if (nkk.eq.14) then
             nkind(i) = 1
             nsi = nsi + 1
          endif
          if (nkk.eq.1)  then
             nkind(i) = 2
             nhydr= nhydr + 1
          endif
          if (nkk.eq.6)  then
             nkind(i) = 3
             ncarb  = ncarb + 1
          endif
          if ((nkk.ne.1).and.(nkk.ne.14).and.(nkk.ne.6)) then
           write(6,*)'ERROR!! unknown atom'
           stop
          endif
 20   continue
      write(6,*)'Si=',nsi,'  H=',nhydr,'  C=',ncarb
c
      read(9,*)
      read(9,*)isub1,iden1,isub2,iden2,isub3,iden3
      write(6,'("region1-6",6I5)')isub1,iden1,isub2,iden2,isub3,iden3
c
      icls = isub1
      isub = iden1
      itmp = isub2 + iden2
      ifix = isub3 + iden3
 1002 format(6e21.13)
 1003 format(3e21.13)
      close(9)
c
      if (iiii.ne.iall) stop 'correct number of atom?'
c
cccc  substrate and indentator temperature
c    3/2*N*kb*T = Sum (1/2*m*v^2) = ekin
c    T = ekin / 3N * 2 ( non-dim. )
cccc  
       do 21 i = 1, isub1 + iden1 + isub2 + iden2
       nk1 = nkind(i)
       if (nk1.eq.1) wg_i = wg_si
       if (nk1.eq.2) wg_i = wg_h
       if (nk1.eq.3) wg_i = wg_c
       ekin(i)=(vx(i)*vx(i)+vy(i)*vy(i)+vz(i)*vz(i))/2.0d0*wg_i
c       write(6,*)ekin(i)
 21   continue
c
      ve_isub1=0.0d0
      ve_iden1=0.0d0
      do 22 i=1,isub1
         ve_isub1=ve_isub1 + ekin(i)
 22   continue
      do 23 i=isub1+1,isub1+iden1
         ve_iden1=ve_iden1+ekin(i)
 23   continue
      if (isub1.ne.0)
     &tnw_isub1 = ve_isub1 / float(isub1) / 3.0 * 2.0
      if (iden1.ne.0)
     &tnw_iden1 = ve_iden1 / float(iden1) / 3.0 * 2.0
      write(6,*)'substrate and indentator temp.',tnw_isub1,tnw_iden1
c
c**** calculate the size of system
      f_number(21)(index+1:70) = '/lattice.dat'
      inquire(file=f_number(21),exist=ex)
c
      if (ex .eq. .true.) then
      write(6,*)'read lattice.dat!'
      open(17,file=f_number(21),status='unknown')
      do i = 1,3
      read(17,'(3e21.13)')hmat(i,1),hmat(i,2),hmat(i,3)
      enddo
      do i = 1,3
      read(17,'(3e21.13)')hmat0(i,1),hmat0(i,2),hmat0(i,3)
      enddo
c
      else
      write(6,*)'lattice is set automatically'
c
      hmat = 0.0d0
      xlmax = maxval(x); xlmin = minval(x)
      ylmax = maxval(y); ylmin = minval(y)
      zlmax = maxval(z); zlmin = minval(z)
      hmat(1,1)= xlmax - xlmin ; hmat0(1,1)=hmat(1,1)
      hmat(2,2)= ylmax - ylmin ; hmat0(2,2)=hmat(2,2)
      hmat(3,3)= zlmax - zlmin ; hmat0(3,3)=hmat(3,3)
c
      endif
c
      write(6,'("system size(Lx,Ly,Lz)",(3e15.7))')
     &hmat(1,1),hmat(2,2),hmat(3,3)
c
ccccc input hmat,smat
      call matcal
      call constant
c
c**** set image vector xi,vxi...
      do 25 i=1,iall
         xi(i)=hmati(1,1)*x(i)+hmati(1,2)*y(i)+hmati(1,3)*z(i)
         yi(i)=hmati(2,1)*x(i)+hmati(2,2)*y(i)+hmati(2,3)*z(i)
         zi(i)=hmati(3,1)*x(i)+hmati(3,2)*y(i)+hmati(3,3)*z(i)
c
         vxi(i)=hmati(1,1)*vx(i)+hmati(1,2)*vy(i)+hmati(1,3)*vz(i)
         vyi(i)=hmati(2,1)*vx(i)+hmati(2,2)*vy(i)+hmati(2,3)*vz(i)
         vzi(i)=hmati(3,1)*vx(i)+hmati(3,2)*vy(i)+hmati(3,3)*vz(i)
 25   continue
c
c--------------------------------------------
ccc      if (nstat.eq.0) then
      write(6,*)
      write(6,*)'*********************************'
      write(6,*)'*     Initialized.....          *'
      write(6,*)'*********************************'
      write(6,*)'Hit return if you are O.K.'
      write(6,*)
c      read
c*****  initilized
c
c
c      write(6,*)'applied stress(from finite deform. theory)'
c      do 71 i=1,3
c      write(6,*)apst0(i,1),apst0(i,2),apst0(i,3)
c 71   continue
c
ccc         endif
c
c*****  not initialized ( sleep now )
       if (nstat.eq.1) then
       write(6,*)'*********************************'
       write(6,*)'*     READ FROM pforce.dat      *'
       write(6,*)'*********************************'
c      write(6,*)'parameter setting O.K?'
c      write(6,*)'init_data.dat --> posi.dat'
c      write(6,*)'init_f.dat --> pforce.dat'
c      write(6,*)'init_lat.dat --> lattice.dat'
c      write(6,*)'Hit return if you are O.K.'
c      write(6,*)
c      read(5,*)
c
c      open(10,file='pforce.dat')
      f_number(3)(index+1:70) = '/pforce.dat'
      open(10,file=f_number(3))
c
      do 220 i=1,iall
         read(10,'(3e21.13)')fx(i),fy(i),fz(i)
 220   continue
c
ccccccccfor nve & npt
       do 230 i=1,iall
          read(10,'(3e21.13)')ddx2(i),ddy2(i),ddz2(i)
 230   continue
c
ccccccc 
      endif
      close(10)
c---------------------------------------------
c      if ((nstat.ne.0).and.(nstat.ne.1)) then
c         write(6,*)'nstat ERROR!!'
c         stop
c      endif
      if (ntemp.eq.0) write(6,*)'temperature is not scaled!!'
      if (ntemp.eq.1) write(6,*)'temperature is scaled!!'
c
      if ((ntemp.ne.1).and.(ntemp.ne.0)) then
         write(6,*)'ERROR!! TEMP_ADJ'
         stop
         endif
c
c--------------------------------------------
c****main loop***** 
c
      write(6,*)'start book-keeping......'
      call book_sic
c      
      write(6,*)'book-keeping OK!'
c
      call tersoff
      call energy
      call monitor
c
      uk0 = uk ; tnw0 = tnw
c     
c*    call delete
c*    if (ndel.ne.0) call book_sic
c     if (ndel.ne.0) stop 'ndel.ne.0'
c     monitor of various values
c      call monitor
c
c*      call book_mlt
c     
c----------------------------------------------------------
ccccc for fem-md start
      allocate(ux(iall),uy(iall),uz(iall))
      allocate(x0(iall),y0(iall),z0(iall))
      allocate(atomep(iall,6))
c      allocate(atomep(iall,6),eps(iall,3,3))
c
      f_number(2)(index+1:70) = '/posi0.dat'
      open(9,file=f_number(2),status='old')
      read(9,*)iiiii;read(9,*)
c
      do i = 1,iall
         read(9,'(i2,6e21.13)')nkk,x0(i),y0(i),z0(i),v01,v02,v03
         ux(i) = x(i) - x0(i); uy(i) = y(i) - y0(i)
         uz(i) = z(i) - z0(i)
c     ux(i)=0.0d0;uy(i)=0.0d0;uz(i)=0.0d0   ! initialization
c     x0(i)=x(i);y0(i)=y(i);z0(i)=z(i)   ! initialization
      enddo
      close(9)
         atomep=0.0d0  ! initialization
c         eps=0.0d0  ! initialization
c
ccccc for fem-md end
      return
      end
