      subroutine molcal
c     use fem_arrays
      use connect
      use work_arrays
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
c      include 'elastic.inc'
c      include 'connect.inc'
c 
cccc initial position + FEM displacement (region3)
c      isub1(region1),iden1(region1),isub2(region2)
c      iden2(region1),isub3(region3),iden3(region1)
      ist = isub1 + iden1 + isub2 + iden2 + 1
      ien = isub1 + iden1 + isub2 + iden2 + isub3
c      write(6,*)'ist,ien(region3)',ist,ien
      do 21 ii = ist,ien
         x(ii) = x0(ii) + ux(ii) 
         y(ii) = y0(ii) + uy(ii) 
         z(ii) = z0(ii) + uz(ii) 
 21   continue
c
c**** set image vector xi,vxi...
      do 25 i=1,iall
      xi(i)=hmati(1,1)*x(i)+hmati(1,2)*y(i)+hmati(1,3)*z(i)
      yi(i)=hmati(2,1)*x(i)+hmati(2,2)*y(i)+hmati(2,3)*z(i)
      zi(i)=hmati(3,1)*x(i)+hmati(3,2)*y(i)+hmati(3,3)*z(i)
      vxi(i)=hmati(1,1)*vx(i)+hmati(1,2)*vy(i)+hmati(1,3)*vz(i)
      vyi(i)=hmati(2,1)*vx(i)+hmati(2,2)*vy(i)+hmati(2,3)*vz(i)
      vzi(i)=hmati(3,1)*vx(i)+hmati(3,2)*vy(i)+hmati(3,3)*vz(i)
 25   continue
c
      avr_sc=0.0d0; avr_at=0.0d0  ! initialize averaged values
c
      imethod = 1
      if (imethod.eq.1) then
      write(6,*)'Molecular Dynamics start'
c
      tot_step = 1.0d0/real(ntsteps)
c averaging interval
      navestep = ntsteps
c
      do 1 ii=1,ntsteps
         nstep=ii 
c        write(6,*)'step=',nstep
c     
c     coordinate & velocity (including tersoff_h.f and press.f)
         call verlet
         call energy  ! energy
         call average ! averaging
c
      if ( mod(nstep,nout_out).eq.0) then
         call out               ! for animation
      endif
c
      if (( mod(nstep,nout_mon).eq.0) .or.
     &    ( mod(nstep,navestep).eq.0)) then
         call monitor           !monitor of various values
      endif
c      
      if (mod(nstep,nbstep).eq.0) then
         call book_sic          ! book-keeping method
      endif
c    
ccccc move the indentator start
ci      if (mod(nstep,100).eq.0) then
ci      ist =  isub1 + iden1 + isub2 + iden2 + isub3 + 1
ci      do i = ist,iall
ci         z(i) = z(i) - 0.1d0
ci         zi(i) = zi(i) - 0.1d0/hmat(3,3)
ci      enddo
ci      ist =  isub1 + iden1 + isub2 + 1
ci      ien =  isub1 + iden1 + isub2 + iden2 
ci      do i = ist,ien
ci         z(i) = z(i) - 0.1d0
ci         zi(i) = zi(i) - 0.1d0/hmat(3,3)
ci      enddo
ci      endif
ccccc move the indentator start end
c
ccccc monitor reaction force start
ci      ist =  isub1 + iden1 + isub2 + iden2 + isub3 + 1
ci      rfz = 0.0d0
ci      do i = ist,iall
ci         rfz = rfz + fz(i)
ci      enddo
ci      ist =  isub1 + iden1 + isub2 + 1
ci      ien =  isub1 + iden1 + isub2 + iden2 + isub3 + 1
ci      rfz2 = 0.0d0
ci      do i = ist,ien
ci         rfz2 = rfz2 + fz(i)
ci      enddo
ci      write(98,*)nstep,rfz,rfz2
ccccc monitor reaction force end
c
 1     continue
c
       else
c
       write(6,*)'Conjugate Gradient Calc. start! '
       vx = 0.0d0 ;vy = 0.0d0 ;vz = 0.0d0 
       call conj_fem ! conjugate gradient
c
       nstep = 1 ; navestep = 1
       call average
c--------------------
c   avr_at(j,*) j=1:kinetic energy  2:potential energy 3:sigma_x 
c                 4:sigma_y 5:sigma_z 6:sigma_xy 7:sigma_xz 8:sigma_yz 
c                 9:x(i) 10:y(i) 11:z(i)
cccc cg method  end ccccccccccccccccccccccccccccccccccccc
c
      endif  ! MD or CG end
c
      s11=1.771861d0;s12=-0.6136595d0;s44e= 1.160005*2.0d0
c
      im_12 = isub1 + iden1 + isub2 + iden2 + isub3
c
      do 95 i = 1,im_12  ! atomistic strain
      atomep(i,1)= s11*avr_at(3,i)+ s12*(avr_at(4,i) + avr_at(5,i))
      atomep(i,2)= s11*avr_at(4,i)+ s12*(avr_at(3,i) + avr_at(5,i))
      atomep(i,3)= s11*avr_at(5,i)+ s12*(avr_at(3,i) + avr_at(4,i))
      atomep(i,4)= s44e*avr_at(6,i)
      atomep(i,5)= s44e*avr_at(7,i)
      atomep(i,6)= s44e*avr_at(8,i)
ccc change the sign tensile -> + , compress --> -
      atomep(i,1)=-atomep(i,1) ; atomep(i,2)=-atomep(i,2) 
      atomep(i,3)=-atomep(i,3) ; atomep(i,4)=-atomep(i,4) 
      atomep(i,5)=-atomep(i,5) ; atomep(i,6)=-atomep(i,6) 
c
 95   continue
c
c      isub1(region1),iden1(region1),isub2(region2)
c      iden2(region1),isub3(region3),iden3(region1)
cccc initial position + FEM displacement (region 1 & 2)
       ien2 = isub1 + iden1 + isub2 + iden2
      do 340 ii = 1,ien2
cccc modified at 00-05-12
c         ux(ii) = x(ii) - x0(ii)
c         uy(ii) = y(ii) - y0(ii)
c         uz(ii) = z(ii) - z0(ii)
         ux(ii) = avr_at(9,ii) - x0(ii)
         uy(ii) = avr_at(10,ii) - y0(ii)
         uz(ii) = avr_at(11,ii) - z0(ii)
 340  continue
c
       return
       end

